#include <gargoyle.h>
#include <stddef.h>

uint8_t gargoyle_digest(uint16_t optc, struct gargoyle_opt *optv, int *argc, char ***argv) {
  while(1) {
    const char *arg = **argv;

    if(!arg || *arg != '-' || !*(arg + 1)) {
      return GARGOYLE_ERR_SUCCESS;
    } else if(*arg == '-' && *(arg + 1) == '-' && !*(arg + 2)) {
      *argc -= 1;
      *argv += 1;
      return GARGOYLE_ERR_SUCCESS;
    }

    struct gargoyle_opt *opt = NULL;

    if(*(arg + 1) == '-') {
      opt = gargoyle_find_brand(optc, optv, arg + 2);

      if(!opt) {
        return GARGOYLE_ERR_UNKNOWN_OPT;
      }
    } else {
      const char *idx = arg + 1;

      for(; *idx; idx += 1) {
        opt = gargoyle_find_emblem(optc, optv, *idx);

        if(!opt) {
          return GARGOYLE_ERR_UNKNOWN_OPT;
        }
      }
    }

    *argc -= 1;
    *argv += 1;
  }

  return GARGOYLE_ERR_SUCCESS;
}
